macro_file HFM_UTIL
/****************************************************************************
                            MULTI-EDIT MACRO FILE

Name: Multi-Edit Hypertext file Manager Version 2.04

str   HFM_BASE()   - Return Hypertext Database name
int   HFM_SCAN()   - Scan accesible hypertext files
void  HFM_RENAME() - Rename hypertext in file

macro HFM_LIST     - Pops up a list of hypertext files
macro HFM_SHOW     - Shows the hypertext file
macro HFM_CNTX     - Supports context sensitive help
macro HFM_INDX     - Create additional index file
macro HFM_MENU     - Menu
macro HFM_ABOUT    - About Hypertext File manager

********(C) Copyright 1995-1997 by Dmitry A.Steklenev **********************/

// $Log: hfm_util.s $
// Revision 1.7  1997/10/12 22:05:27  GLASS
// - Fixed minor bug in "Create Index File" module.
//
// Revision 1.6  1997/05/27 15:57:15  GLASS
// - New Version 2.03 (installation changed)
//
// Revision 1.5  1996/05/22 19:39:01  GLASS
// - Fixed very small bug.
//
// Revision 1.4  1996/05/15 19:38:53  GLASS
// - Add "Create Index File" module;
// - Automated exit from ME after installation.
//
// Revision 1.3  1996/01/19 22:12:53  GLASS
// - Changed the block size via HelpCX (new size = 15 Kb)
//
// Revision 1.2  1996/01/09 21:17:47  GLASS
// - Fixed Bugs in keymap installation
//
// Revision 1.1  1996/01/03 23:52:57  GLASS
// Initial revision
//

str HFM_BASE TRANS () {
/********************************MULTI-EDIT MACRO****************************

Name:        HFM_BASE()
Description: Return Hypertext Database name

********(C) Copyright 1995-1997 by Dmitry A.Steklenev **********************/

  if( global_str('@DB_EXTENSION') == '')
      return_str = 'HFM.DB';
  else
      return_str = 'HFM.' + global_str('@DB_EXTENSION');

  rm( 'MAKEUSERPATH /DF=1' );
  return( return_str );
}


int HFM_SCAN TRANS () {
/********************************MULTI-EDIT MACRO****************************

Name:        HFM_SCAN()
Description: Scan accesible hypertext files.

********(C) Copyright 1995-1997 by Dmitry A.Steklenev **********************/

  str curdir[64]  = me_path();
  int lvldir      = 0 ;

  str dbrec[250]  = "";
  int dbhandle    = 0 ;
  int dberror     = 0 ;
  int dbwrite     = 0 ;
  str dbname[250] = HFM_BASE();

  int curwinid    = window_id();
  int notfound    = 0 ;

  int boxheight   = 15;
  int boxwidth    = 76;

  int ul_col, ul_row, lr_col, lr_row, i;

  if (switch_file(dbname))
  {
     save_file;
     delete_window;
  }

  switch_win_id( curwinid );
  redraw;

  ul_row = (screen_length - boxheight)/2 + 1;
  ul_col = (screen_width  - boxwidth )/2 + 1;
  lr_row = ul_row + boxheight;
  lr_col = ul_col + boxwidth;

  put_box( ul_col,
           ul_row,
           lr_col,
           lr_row, 0, m_b_color, "[Scanning ACI Hypertext Files...]", true );

  set_vp( ul_col + 1,
          ul_row + 1,
          lr_col - 3,
          lr_row - 2 );

  text_color_vp = m_s_color;

  dberror = s_create_file( dbname, dbhandle );
  if ( dberror != 0 ) goto errbase;

  dbrec = "@DISPLAY_STRING=NAME=0";
  call writerecord;
  dbrec = "/C=1/L=2/W=65/QK=1/T=Name:/DBF=NAME/TP=0/H=HFM^EDIT";
  call writerecord;
  dbrec = "/C=1/L=1/W=65/ML=150/QK=1/T=File:/DBF=FILE/TP=8/H=HFM^EDIT/M=HFM_UTIL^HFM_FILE" ;
  call writerecord;
  dbrec = "****START****";
  call writerecord;

  set_global_str( "HYPER_DIRS", me_path + ";" + me_path + "HELP\\;" );
  call scanfile;

  s_close_file( dbhandle );
  kill_box();
  return(true);

scanfile: /************* Scan files ****************************************/

  write_vp( "> Dir " + curdir + " scanning..\n\r" );
  file_search_attr = 0x3f;
  notfound = first_file( curdir + "*.*" );

  while ( notfound == 0 ) {
        if( last_file_attr & 0x10 )
        {
            if((last_file_name != '.') and (last_file_name != '..'))
            {
                call pushstate;
                curdir = curdir + last_file_name + "\\";
                call scanfile;
                call popstate;
            }
        }
        else
        {
            if(( get_extension(last_file_name) == "HLP" ) or
               ( get_extension(last_file_name) == "HLZ" ))
            {
                 str curfile[13] = lower(last_file_name);
                 int isskip = 0;

                 // List of files, which will be skipped at scanning.
                 // This standard files of the help of the MULTI-EDIT.
                 // If you want, that the file has got in a data base
                 // of the Hypertext File Manager, make comment a
                 // line with file name.

                 if (curfile == "aci_hype.hlz") isskip=1;
                 if (curfile == "asm.hlz"     ) isskip=1;
                 if (curfile == "basic.hlz"   ) isskip=1;
                 if (curfile == "brief.hlz"   ) isskip=1;
                 if (curfile == "c.hlz"       ) isskip=1;
                 if (curfile == "cmac.hlz"    ) isskip=1;
                 if (curfile == "cobol.hlz"   ) isskip=1;
                 if (curfile == "commod.hlz"  ) isskip=1;
                 if (curfile == "dbase.hlz"   ) isskip=1;
                 if (curfile == "dirshell.hlz") isskip=1;
                 if (curfile == "ev_asist.hlz") isskip=1;
                 if (curfile == "ev_clipr.hlz") isskip=1;
                 if (curfile == "ev_dbase.hlz") isskip=1;
                 if (curfile == "ev_fxpro.hlz") isskip=1;
                 if (curfile == "filemngr.hlz") isskip=1;
                 if (curfile == "fortran.hlz" ) isskip=1;
                 if (curfile == "hfm.hlz"     ) isskip=1;
              // if (curfile == "macro.hlz"   ) isskip=1;
                 if (curfile == "me.hlz"      ) isskip=1;
                 if (curfile == "mecom.hlz"   ) isskip=1;
                 if (curfile == "mecommac.hlz") isskip=1;
                 if (curfile == "medebug.hlz" ) isskip=1;
                 if (curfile == "metags.hlz"  ) isskip=1;
                 if (curfile == "modula_2.hlz") isskip=1;
                 if (curfile == "notebook.hlz") isskip=1;
                 if (curfile == "pascal.hlz"  ) isskip=1;
                 if (curfile == "prnform.hlz" ) isskip=1;
                 if (curfile == "quickref.hlz") isskip=1;
                 if (curfile == "spell.hlz"   ) isskip=1;
                 if (curfile == "src.hlz"     ) isskip=1;
                 if (curfile == "vcs.hlz"     ) isskip=1;
                 if (curfile == "vcs_inst.hlz") isskip=1;
                 if (curfile == "wordstar.hlz") isskip=1;

                 pad_str( curfile, 13, " " );
                 write_vp( "   " + curfile + " ");

                 if (isskip == 0)
                    call gethelpname;
                 else
                    write_vp( "[skipped]" );

                 write_vp( "\n\r" );
            }
        }
        notfound = next_file();
  }
  ret;

writerecord: /********** Write record to data base *************************/

  dberror = s_write_bytes( dbrec + "\r\n", dbhandle, dbwrite );
  if (( dberror != 0 ) or (length(dbrec)+2 < dbwrite ))
     goto errbase;

  ret;

gethelpname: /********** Get hypertext name ********************************/

  set_virtual_display();
  help_size_window( ul_col, ul_row, lr_col, lr_row );
  help_start;
  help_open_file( curdir + last_file_name );

  help_select( '*' );
  help_update;

  dbrec = "NAME=" + remove_space( copy( help_chapter_title, 1, 65 ));

  while(( i = xpos( '', dbrec, 1 )) != 0 )
    dbrec = str_ins( '*', str_del( dbrec, i, 1 ), i );

  while(( i = xpos( char(0), dbrec, 1 )) != 0 )   // Correct Ng2Me v1.0
    dbrec = str_del( dbrec, i, 1 );               // error.

  dbrec = dbrec + "FILE=" + curdir + last_file_name;

  clear_virtual_display();
  reset_virtual_display();

  write_vp( copy( help_chapter_title, 1, 40));

  call writerecord;
  help_done;

  // Use HFM_INST:

  if( xpos( curdir + ";", global_str("HYPER_DIRS"), 1 ) == 0)
      set_global_str( "HYPER_DIRS", global_str("HYPER_DIRS") + curdir + ";" );

  ret;

pushstate: /************ Save status ***************************************/

  ++lvldir;
  set_global_str( "HYPER_SCAN_DIR_"   + str(lvldir), curdir );
  set_global_str( "HYPER_SCAN_STATE_" + str(lvldir), file_search_rec);
  ret;

popstate:  /************ Restore status ***********************************/

  curdir = global_str( "HYPER_SCAN_DIR_" + str(lvldir));
  file_search_rec = global_str( "HYPER_SCAN_STATE_" + str(lvldir));

  set_global_str( "HYPER_SCAN_DIR_"   + str(lvldir), "" );
  set_global_str( "HYPER_SCAN_STATE_" + str(lvldir), "" );

  --lvldir;
  ret;

errbase: /************** Error ********************************************/

  error_level = 0;
  rm( "MEERROR^MESSAGEBOX /T="  + "[HYPERTEXT FILE MANAGER]" +
                         "/B=1" +
                         "/M=Write Error in file " + dbname );

  s_close_file( dbhandle );
  kill_box();
  return(false);
}


void HFM_RENAME ( str name, str  file ) TRANS {
/********************************MULTI-EDIT MACRO****************************

Name:        HFM_RENAME()
Description: Rename hypertext in file

********(C) Copyright 1995-1997 by Dmitry A.Steklenev **********************/

  str type = caps( get_extension( file ));

  str errmsg;
  int curwinid = window_id;

  if( type == "HLZ" )
  {
    if( file_exists( me_path + 'utils\helpdx.exe' ) == 1 )
        return_str = me_path + 'utils\helpdx.exe ' + file;
    else
        return_str = 'helpdx.exe ' + file;

    rm( 'MEUTIL1^EXEC /SCREEN=2' );

    if( exit_code != 0 ) {
        errmsg = "Can't find: HELPDX.EXE";
        goto error;
    }

    file = truncate_extension(file) + ".HLP";
  }

  rm( 'MEERROR^MESSAGEBOX '          +
      '/NW=1'                        +
      '/T=RENAMING HYPERTEXT'        +
      '/M=Renaming Hypertext file: ' + file );

  create_window;
  error_level = 0;
  load_file( file );

  if( error_level) {
      kill_box();
      delete_window;
      errmsg = "Can't find: " + file;
      goto error;
  }

  window_attr = $81;

  reg_exp_stat = false;
  if( search_fwd( char(12) + "* ", 0 )) del_line; else tof;

  home; cr; up; home;
  put_line( char(12) + "* " + name );

  save_file;
  kill_box();
  delete_window;

  if( type == "HLZ" )
  {
    if( file_exists( me_path + 'utils\helpcx.exe' ) == 1 )
        return_str = me_path + 'utils\helpcx.exe ' + file + ' /15';
    else
        return_str = 'helpcx.exe ' + file + ' /15';

    rm( 'MEUTIL1^EXEC /SCREEN=2' );
    del_file( file );

    if( exit_code != 0 ) {
        errmsg = "Can't find: HELPCX.EXE";
        goto error;
    }
  }

  switch_win_id( curwinid );
  return();

error:

  error_level = 0;
  rm( "MEERROR^MESSAGEBOX /T="  + "[HYPERTEXT FILE MANAGER]" +
                         "/B=1" +
                         "/M="  + errmsg );

  switch_win_id( curwinid );
  return();
}


macro HFM_LIST TRANS {
/********************************MULTI-EDIT MACRO****************************

Name:        HFM_LIST
Description: Pops up a list of hypertext files
Parameters:  /SEL=1 select hypertext only

********(C) Copyright 1995-1997 by Dmitry A.Steklenev **********************/

  str dbname[250] = HFM_BASE();
  int sel = 0;

  sel = parse_int("/SEL=", mparm_str );

  if( first_file( dbname ) != 0 ) {
      return_int = 100;
      goto execlist;
  }

  if( last_file_size() == 0) {
      return_int = 100;
      goto execlist;
  }

showlist:

  set_global_str( "HYPER_BTN1", '/TP=11/T=ReScan/KC=<F10>/W=11/K1=0/K2=68/R=100' );

  rm( 'USERIN^DB '                         +
      '/2TOP=1'                            +
      '/NDF=1'                             +
      '/F=' + dbname                       +
      '/SRP=1'                             +
      '/GLO=HYPER_FILE'                    +
      '/NOALPHA=1'                         +
      '/LO=2'                              +
      '/EBC=1'                             +
      '/EBN=HYPER_BTN'                     +
      '/LT=[HYPERTEXT FILE MANAGER V2.04]' +
      '/DT=[HYPERTEXT FILE SETUP]'         +
      '/ABT=Show'                          +
      '/H=HFM^LIST'                        +
      '/MACRO=HFM_EDIT'
    );

  set_global_str( "HYPER_SCANBTN1", "" );

  if( return_int == 1 && sel == 1 )
  {
    return_str = parse_str("FILE=", global_str( "HYPER_FILE" ));
    return();
  }

execlist:

  switch( return_int )
  {
    case   1: rm( 'HFM_SHOW /NEW=1' );       break;
    case 100: if( HFM_SCAN()) goto showlist; break;
  }
}

macro HFM_FILE TRANS {

  return_str = parse_str("FILE=", global_str( "HYPER_FILE" ));
  rm( 'MEUTIL1^FILE_PROMPT /T=[SELECT HYPERTEXT FILE]/H=HFM^EDIT' );
  redraw;
}

macro HFM_EDIT TRANS {

  int after   = parse_int("/P="   , mparm_str );
  str global  = parse_str("/GLO=" , mparm_str );
  str name    = parse_str("NAME=", global_str( global ));
  str file    = parse_str("FILE=", global_str( global ));

  if( !after )
  {
    set_global_str( "HYPER_NAME", name );
    set_global_str( "HYPER_DISK", file );
  }
  else
  {
    if(( global_str( "HYPER_DISK") != file ) and
       ( global_str( "HYPER_DISK") != ""   ) and !file_exists(file))
    {
      rm( 'USERIN^VERIFY '                         +
          '/T=Rename Hypertext file?'              +
          '/S=0'                                   +
          '/L=10'                                  +
          '/BL=[HYPERTEXT FILE MANAGER]'           +
          '/H=HFM^FILERENAME'                      );
      if( return_int )
          rename_file( global_str("HYPER_DISK"), file );
    }
    if(( global_str( "HYPER_NAME") != name ) and
       ( global_str( "HYPER_NAME") != ""   )   )
    {
      rm( 'USERIN^VERIFY '                         +
          '/T=Change Hypertext name in file?'      +
          '/S=0'                                   +
          '/L=10'                                  +
          '/BL=[HYPERTEXT FILE MANAGER]'           +
          '/H=HFM^TEXTRENAME'                      );
      if( return_int )
          HFM_RENAME( name, file );
    }
  }
}


void HFM_SHOW TRANS {
/********************************MULTI-EDIT MACRO****************************

Name:        HFM_SHOW()

Description: Shows the hypertext file

Parameters:  /NEW=1  new hypertext
             /LK=str link (if /NEW=1)

********(C) Copyright 1995-1997 by Dmitry A.Steklenev **********************/

  str file[150], link[250];
  int new = 0, index = 0;

  file  = parse_str("FILE=", global_str( "HYPER_FILE" ));
  new   = parse_int("/NEW=", mparm_str );
  link  = parse_str("/LK=", mparm_str );

  if( file != '' )
  {
    if( new )
    {
      call cleastate;
      rm( "MEHELP /CX=0 /W=79 /F=" + file + "/LK=" + link );
    }
    else
    {
      call reststate;
      rm( "MEHELP /CX=0 /W=79 /POP=1" );
    }
    call savestate;
  }
  else
    rm( 'HFM_LIST' );

  return();

savestate: /****************************************************************/

  set_global_int( "HYPER_STACK", index = global_int( "@HSTACK" ));
  for( ; index > 0 ; index-- )
    set_global_str( "HYPER_STACK_" + str(index),
        global_str( "@HSTACK"      + str(index))  );
  ret;

reststate: /***************************************************************/

  set_global_int( "@HSTACK", index = global_int( "HYPER_STACK" ));
  for( ; index > 0; index-- )
    set_global_str( "@HSTACK"      + str(index),
        global_str( "HYPER_STACK_" + str(index)) );

  ret;

cleastate: /***************************************************************/

  index = global_int( "HYPER_STACK");
  set_global_int( "@HSTACK"    , 0 );
  set_global_int( "HYPER_STACK", 0 );

  for( ; index > 0; index-- )
    set_global_str( "HYPER_STACK_" + str(index), "" );

  ret;
}


macro HFM_CNTX TRANS {
/********************************MULTI-EDIT MACRO****************************

Name:        HFM_CNTX
Description: Supports context sensitive help

********(C) Copyright 1995-1997 by Dmitry A.Steklenev **********************/

  str cntx[150], help_path[256], help_list[256], help_file[256], msg[200];
  int cpos;

  return_str = '';
  rm( "MEHELP^GET_CONTEXT" );
  cntx = caps( return_str  );

  help_path = global_str('!HELP_PATH!');
  if( help_path == "" ) help_path = me_path + 'HELP'  + ';' +
                                    me_path           + ';' +
                                    me_path + 'HYPER' ;
  return_str = help_path;
  rm("XLATECMDLINE");
  help_path = return_str;

  rm( "FIND_EXT /EXT=." + get_extension( file_name ));
  help_list = parse_str('HLP=', global_str( return_str ));
  if( help_list == "" ) help_list = global_str( "HYPER_FILE" );

SearchCntx: /**************************************************************/

  working;
  call NextFile;

  make_message( "Search '" + cntx + "' in " + help_file + "..." );

  set_virtual_display();
  help_size_window( 0,0,40,25 );

  help_start;
  help_open_file( help_file );
  help_select( "INDEX" );
  help_update;
  help_search( cntx, 0 );

  if( !error_level )
  {
    msg  = "";
    return_int = 1;
    set_global_str( "HYPER_FILE", "FILE=" + help_file );
  }
  else
  {
    error_level = 0;
    return_int  = 0;
    msg  = "Context not found.";
  }

  clear_virtual_display();
  reset_virtual_display();
  help_done;

  make_message( msg );
  if( !return_int ) goto SearchCntx;

  rm( "HFM_SHOW /NEW=1 /LK=INDEX%" + cntx );
  return();

NextFile: /***************************************************************/

  if( help_list == "" ) return();

  if(( cpos = xpos( ";", help_list, 1 )) == 0 )
  {
    help_file = help_list;
    help_list = "";
  }
  else
  {
    help_file = copy( help_list, 1, cpos - 1   );
    help_list = copy( help_list, cpos + 1, 256 );
  }

  if( get_extension( help_file ) == "" )
    help_file = help_file + ".HL?";

  return_str = help_path;
  rm( "PATHSEARCH /F=" + help_file );

  if( !return_int ) goto NextFile;
  help_file = return_str;

  if( get_extension( help_file ) == "HL?" )
  {
    help_file = truncate_extension( help_file );
    if( file_exists( help_file + ".HLP" ))
        help_file = help_file  + ".HLP";
    else
        help_file = help_file  + ".HLZ";
  }

  ret;
}


macro HFM_INDX TRANS {
/********************************MULTI-EDIT MACRO****************************

Name:        HFM_INDX
Description: Create Additional Index File

********(C) Copyright 1995-1997 by Dmitry A.Steklenev **********************/

  int menu = menu_create;

  menu_set_item( menu, 1, "Hypertext File:", "", "/QK=1/L=2/W=50/C=1/M=HFM_LIST /SEL=1", 8,0,0 );
  menu_set_item( menu, 2, "Index String:  ", "", "/QK=1/L=3/W=52/C=1", 0,0,0 );

  return_int = menu;
  rm("USERIN^DATA_IN /T=[HYPERTEXT FILE INDEX BUILDER]/#=2/HN=1/H=HFM^CREATEINDEX" );

  str hyper[256], index[256], string[256], hypext[3], name[256];
  int idxno = 1;

  hyper  = menu_item_str( menu, 1, 2 );
  hypext = caps( get_extension( hyper ));
  string = menu_item_str( menu, 2, 2 );
  menu_delete(menu);

  if( !return_int or (hyper == "") or (string == ""))
    return();

  index = truncate_extension( truncate_path(hyper));
  if( length( index ) > 6 ) index = copy( index, 1, 6 );

  while (
    ( file_exists( get_path(hyper) + index + str(idxno) + ".HLZ" ) != 0 ) and
    ( idxno <= 99 ))
    ++idxno;

  if( idxno > 99 ) return();

  if( idxno < 10 )
    index = index + "0";

  index = get_path(hyper) + index + str( idxno );

  str errmsg;
  int curwinid = window_id;

  if( hypext == "HLZ" )
  {
    if( file_exists( me_path + 'utils\helpdx.exe' ) == 1 )
        return_str = me_path + 'utils\helpdx.exe ' + hyper;
    else
        return_str = 'helpdx.exe ' + hyper;

    rm( 'MEUTIL1^EXEC /SCREEN=2' );

    if( exit_code != 0 ) {
        errmsg = "Can't find: HELPDX.EXE";
        goto error;
    }

    hyper = truncate_extension(hyper) + ".HLP";
  }

  rm( 'MEERROR^MESSAGEBOX '       +
      '/NW=1'                     +
      '/T=CREATING INDEX'         +
      '/M=Searching Master Index' );

  create_window;
  error_level = 0;
  load_file( hyper );

  if( error_level) {
      kill_box();
      delete_window;
      errmsg = "Can't find: " + hyper;
      goto error;
  }

  int hypwin  = window_id;
  window_attr = $81;

  reg_exp_stat = false;
  ignore_case = true;

  if( search_fwd( char(12) + "* ", 0 ))
    name = get_line();

  if( !search_fwd( char(12) + "INDEX ", 0 ))
  {
      kill_box();
      delete_window;

      if ( hypext == "HLZ" )
           del_file( hyper );

      errmsg = "Can't find master index: " + hyper;
      goto error;
  }

  create_window;
  file_name   = index + ".HLP";
  int idxwin  = window_id;
  window_attr = $81;
  put_line( name + " [" + string + "]" );

  switch_win_id( hypwin );
  kill_box();

  rm( 'MEERROR^MESSAGEBOX '          +
      '/NW=1'                        +
      '/T=CREATING INDEX'            +
      '/M=Creating Hypertext file: ' + index );

  while( search_fwd( string, 0 ))
  {
    name = get_line();
    name = str_ins( truncate_extension( truncate_path(hyper)) + "^",name,2 );
    switch_win_id( idxwin );
    eol; cr; put_line( name );
    switch_win_id( hypwin );
    down;
  }

  switch_win_id( hypwin );
  delete_window;
  switch_win_id( idxwin );
  save_file;
  delete_window;
  kill_box();

  if( file_exists( me_path + 'utils\helpcx.exe' ) == 1 )
      return_str = me_path + 'utils\helpcx.exe ' + index + '.HLP /15';
  else
      return_str = 'helpcx.exe ' + index + '.HLP /15';

  rm( 'MEUTIL1^EXEC /SCREEN=2' );
  del_file( index + ".HLP" );

  if ( hypext == "HLZ" )
       del_file( hyper );

  if( exit_code != 0 ) {
      errmsg = "Can't find: HELPCX.EXE";
      goto error;
  }

  switch_win_id( curwinid );
  hfm_scan();
  return();

error:

  error_level = 0;
  rm( "MEERROR^MESSAGEBOX /T="  + "[HYPERTEXT FILE MANAGER]" +
                         "/B=1" +
                         "/M="  + errmsg );

  switch_win_id( curwinid );
  return();
}


macro HFM_MENU TRANS {
/********************************MULTI-EDIT MACRO****************************

Name:        HFM_MENU
Description: Menu

********(C) Copyright 1995-1997 by Dmitry A.Steklenev **********************/

  rm('MENU /MN=HFM_MENU' + mparm_str );
}

macro _MN_HFM_MENU TRANS {

  int menu = return_int;

  menu_set_item( menu, 1, "Pops up a list of hypertext files"     , global_str("!HFM_LST"), "/S=2/H=/NM=1/ CMD=HFM_LISTTYPE=1CS=0" , 0,0,0 );
  menu_set_item( menu, 2, "Shows the hypertext file         "     , global_str("!HFM_SHW"), "/S=2/H=/NM=1/ CMD=HFM_SHOWTYPE=1CS=0" , 0,0,0 );
  menu_set_item( menu, 3, "sUpports context sensitive help  "     , global_str("!HFM_CNT"), "/S=2/H=/NM=1/ CMD=HFM_CNTXTYPE=1CS=0" , 0,0,0 );
  menu_set_item( menu, 4, "Create Index file                "     , ""                    , "/S=2/H=/NM=1/ CMD=HFM_INDXTYPE=1CS=0" , 0,0,0 );
  menu_set_item( menu, 5, ""                                      , ""                    , "/S=2/H=/NM=1/ TYPE=6CS=0"              , 1,0,0 );
  menu_set_item( menu, 6, "About...                         "     , ""                    , "/S=2/H=/NM=1/ CMD=HFM_ABOUTTYPE=1CS=0", 0,0,0 );

  return_int = menu;
  return_str = "/T=[HYPERTEXT FILE MANAGER]/H=HFM^MENU/#=6";
}

macro HFM_ABOUT TRANS {
/********************************MULTI-EDIT MACRO****************************

Name:        HFM_ABOUT
Description: About Hypertext File manager

********(C) Copyright 1995-1997 by Dmitry A.Steklenev **********************/

  int  menu = menu_create;

  menu_set_item( menu, 1, 'ķ ڷ          ķ          ķ                ','', '/L=1/C=4/ATTR=' + str( m_s_color ), 10, 0, 0);
  menu_set_item( menu, 2, '            ͼ          ͼ                ','', '/L=2/C=4/ATTR=' + str( m_s_color ), 10, 0, 0);
  menu_set_item( menu, 3, ' ٺڷ ڷķķ ķķķ ķ ķķ   ','', '/L=3/C=4/ATTR=' + str( m_s_color ), 10, 0, 0);
  menu_set_item( menu, 4, ' ͸ ɸ ͼ ͼ͸ͼͼ ڽ͸ͼ   ','', '/L=4/C=4/ATTR=' + str( m_s_color ), 10, 0, 0);
  menu_set_item( menu, 5, '  ٺ ķ      ķĿ       ','', '/L=5/C=4/ATTR=' + str( m_s_color ), 10, 0, 0);
  menu_set_item( menu, 6, 'ͼ Լ͸ͼͼԼ    Լ  ͼͼ ͼ  Լ     ','', '/L=6/C=4/ATTR=' + str( m_s_color ), 10, 0, 0);
  menu_set_item( menu, 7, '      ٺ    F I L E   M A N A G E R        ','', '/L=7/C=4/ATTR=' + str( m_s_color ), 10, 0, 0);
  menu_set_item( menu, 8, '      ͼԼ                                         ','', '/L=8/C=4/ATTR=' + str( m_s_color ), 10, 0, 0);

  menu_set_item( menu, 9, '                Version 2.04'                 ,'', '/L=09/C=7', 10, 0, 0);
  menu_set_item( menu,10, 'Copyright (C) 1995-1997 by Dmitry A.Steklenev','', '/L=11/C=7', 10, 0, 0);
  menu_set_item( menu,11, '             All Rights Reserved'             ,'', '/L=12/C=7', 10, 0, 0);

  return_int = menu;
  RM('USERIN^DATA_IN /HN=1/H=HFM^*/A=1/#=11/T=');
	menu_delete( menu );
}
